package cpcns.dingZhi.rili.service.impl;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import cpcns.base.common.User;
import cpcns.dangAnBase.base.service.impl.DangAnBaseServiceImpl;
import cpcns.dingZhi.rili.dao.IRiLiDao;
import cpcns.dingZhi.rili.model.riLi;
import cpcns.dingZhi.rili.service.IRiLiService;
import cpcns.utils.DateUtil;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.apache.commons.lang.StringUtils;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service("riLiService")
public class RiLiServiceImpl extends DangAnBaseServiceImpl<riLi> implements IRiLiService {
  private static final Logger logger = Logger.getLogger(cpcns.dingZhi.rili.service.impl.RiLiServiceImpl.class);
  
  @Autowired
  private IRiLiDao riLiDao;
  
  public List<Map<String, Object>> getAll(String startMonth) {
    String sql = "select * from G_JIEJIARI where leiXing!=0 and riqi like '%" + startMonth + "%'";
    List<Map<String, Object>> rl = this.riLiDao.getListMap(sql);
    return rl;
  }
  
  public void setRiLi(String startYear, String endYear, String mingCheng, int leiXing, User user) {
    StringBuffer years = new StringBuffer();
    if (startYear.indexOf("-") > 0) {
      years = DateUtil.dayBetweenDayS(startYear, endYear);
    } else {
      years = DateUtil.getYears(Integer.parseInt(startYear), Integer.parseInt(endYear));
    } 
    if (StringUtils.isNotBlank(years.toString())) {
      String[] str = years.toString().split(",");
      int hbs = getHB();
      String sql = "select hangBiaoShi from G_JIEJIARI where riQi=:riQi";
      Map<String, Object> tp = new HashMap<>();
      for (int i = 0; i < str.length; i++) {
        tp.put("riQi", str[i]);
        List re = this.riLiDao.getList(sql, tp);
        riLi rl = new riLi();
        if (re == null || re.size() == 0) {
          rl.setHangBiaoShi(hbs + i);
          rl.setRiQi(str[i]);
          rl.setMingCheng(mingCheng);
          rl.setSheZhiRenBiaoShi(user.getBiaoShi().intValue());
          rl.setSheZhiRenMingCheng(user.getMingCheng());
          rl.setSheZhiDate(new Date());
          rl.setLeiXing(leiXing);
          this.riLiDao.save(rl);
        } else {
          int hbs_ = Integer.parseInt(String.valueOf(re.get(0)));
          rl.setHangBiaoShi(hbs_);
          rl.setRiQi(str[i]);
          rl.setMingCheng(mingCheng);
          rl.setSheZhiRenBiaoShi(user.getBiaoShi().intValue());
          rl.setSheZhiRenMingCheng(user.getMingCheng());
          rl.setSheZhiDate(new Date());
          rl.setLeiXing(leiXing);
          this.riLiDao.update(rl);
        } 
      } 
    } 
  }
  
  private int getHB() {
    String sql = "select max(hangBiaoShi) from G_JIEJIARI ";
    List hb = this.riLiDao.getList(sql);
    int hbs = 4;
    if (hb != null && hb.size() > 0 && !hb.equals("null"))
      hbs = Integer.parseInt(String.valueOf(hb.get(0))) + 1; 
    return hbs;
  }
  
  public void setSXBSJ(String sb, String XB, String hbs, User user) {
    riLi rl = new riLi();
    rl.setSheZhiRenBiaoShi(user.getBiaoShi().intValue());
    rl.setSheZhiRenMingCheng(user.getMingCheng());
    rl.setSheZhiDate(new Date());
    rl.setKaiShi(sb);
    rl.setJieShu(XB);
    rl.setMingCheng("上下班时间");
    rl.setHangBiaoShi(1);
    rl.setLeiXing(0);
    if ("0".equals(hbs)) {
      this.riLiDao.save(rl);
    } else {
      this.riLiDao.update(rl);
    } 
  }
}
